package annotator;

import java.sql.*;
import java.util.ArrayList;

import javax.swing.JOptionPane;


public class DB
{
	private Connection con;
	
	
	String host = "128.208.247.3";
	int port = 3306;
	//String host = "localhost";
	//int port = 8889;
    String url = "jdbc:mysql://" + host + ":" + port + "/";
    String db = "prise_test";
    String driver = "com.mysql.jdbc.Driver";
    
    String user = "dev";
    String pass = "prise-dev!";
    //String user = "root";
    //String pass = "root";
    //String user = "developer";
    //String pass = "FpAeAnFbS8T3FUE4";
    
    
    public DB()
    {
    	con = null;
    }
    
    protected void finalize()
    {
    	disconnect();
    }
    
    public void connect()
    {
    	connect("", "", "");
    }
    
    public void connect(String username, String password)
    {
    	connect(username, password, "");
    }
    
    public void connect(String username, String password, String database)
    {
    	if (con == null)
    	{
	    	try
	    	{
	    		if (username != "")
	    		{
	    			user = username;
	    			pass = password;
	    		}
	    		if (database != "")
	    			db = database;
	    		
		    	Class.forName(driver).newInstance();
			    con = DriverManager.getConnection(url+db, user, pass);
	    	}
	    	catch (Exception e)
	    	{
	    		System.err.println("Unable to connect to SQL server.");
	    		System.err.println(e.getMessage());
	    	}
    	}
    }
    
    public void disconnect()
    {
    	if (con != null)
    	{
    		try
	    	{
    			con.close();
    			con = null;
	    	}
	    	catch (Exception e)
	    	{
	    		System.err.println("Error closing SQL connection.");
	    	}
    	}
    }
    
    public ResultSet querySelect(String query)
    {
    	ResultSet res;

    	try
    	{
			Statement st = con.createStatement();
			res = st.executeQuery(query);
			return res;
    	}
		catch (SQLException s)
		{
			System.err.println("SQL code does not execute.");
			System.err.println(s.getMessage());
		}    

  	    return null;
    }
    
    public int queryUpdate(String query)
    {
    	int res;
    	
  	    try
  	    {
  	    	Statement st = con.createStatement();
  	        res = st.executeUpdate(query);
  	        st.close();
  	        
  	        return res;
  	    }
  	    catch (SQLException s)
  	    {
  	        System.err.println("SQL code does not execute.");
  	        System.err.println(s.getMessage());
  	    }
  	    
    	return 0;
    }
    
    public int lastInsertId()
    {
    	ResultSet res;

    	try
    	{
			Statement st = con.createStatement();
			res = st.executeQuery("SELECT LAST_INSERT_ID() as id");
			res.next();
			
			return res.getInt("id");
    	}
		catch (SQLException s)
		{
			System.err.println("SQL code does not execute.");
			System.err.println(s.getMessage());
		}
		
		return 0;
    }
    
    public int[] queryBatch(ArrayList<String> statements) throws SQLException
    {
    	int[] res = {};
    	
  	    
        Statement st = con.createStatement();
        
        for (String statement : statements)
        {
        	st.addBatch(statement);
        }
        res = st.executeBatch();
        
        return res;
    }
    
    /**
     * Sanitize input for database 
     * @param s
     * @return
     */
    public static String clean( String s)
    {
       if (s == null)  return s;
       //if (f == null)  return s;
       //if (r == null)  r = "";
       String f = "\'";
       String r = "\\\'";

       int index01 = s.indexOf( f );
       while (index01 != -1)
       {
          s = s.substring(0,index01) + r + s.substring(index01+f.length());
          index01 += r.length();
          index01 = s.indexOf( f, index01 );
       }
       return s;
    }
    
    /**
     * Stripslahes equivalent
     * @param s
     * @return
     */
    public static String unClean( String s)
    {
       if (s == null)  return s;
       //if (f == null)  return s;
       //if (r == null)  r = "";
       String f = "\\\'";
       String r = "\'";

       int index01 = s.indexOf( f );
       while (index01 != -1)
       {
          s = s.substring(0,index01) + r + s.substring(index01+f.length());
          index01 += r.length();
          index01 = s.indexOf( f, index01 );
       }
       return s;
    }
}
