/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package deeper.entities.rm.io;

import com.rapidminer.operator.ResultObjectAdapter;
import com.rapidminer.tools.LogService;
import com.rapidminer.tools.Ontology;
import com.rapidminer.tools.container.Pair;

import deeper.entities.Interaction;
import deeper.entities.enums.InteractionLabel;
import deeper.entities.graph.Graph;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;

/**
 * This is not a mere wrapper of interaction object for RM passing purposes.
 * This object is used to set the features that are used by Text2ExampleSetOeprator
 * to generate an example set.
 *
 * @author tfairuzo
 */
public class InteractionIO extends ResultObjectAdapter{

    /**
	 * 
	 */
	private static final long serialVersionUID = -6155030203581986423L;

	private Interaction interaction;

    //Key is a feature name, Key in value is a value of the feature
    //and value in value pair is a rapidminer data type (in terms of ontology).
    private Map<String, Pair<Object,Integer>> valueMap = new HashMap<String,Pair<Object,Integer>>();
    
    //public static final String[] ROLES = new String[]{"tree"};

    //public static final int TREE = 0;
    //public static final int STRING = 1;

    public InteractionIO(Interaction interaction){
        this.interaction = interaction;
    }
    
    public Interaction getInteraction(){
    	return interaction;
    }

    /*public Graph getDepPath(){
        return interaction.getDepPath();
    }

    public Graph getParsePath(){
        return interaction.getParsePath();
    }
    
    public InteractionLabel getLabel(){
        return interaction.label;
    }*/

    /*public String getSentenceText(){
        return interaction.getSentenceText();
    }
    
    public String getSentenceMod(){
        return interaction.getSentenceMod();
    }

    public String getSentenceUniqueId(){
        return interaction.getSentenceUniqueId();
    }

    public String getUniqueId(){
        return interaction.getUniqueId();
    }

    public Graph getSentenceDepTree(){
        return interaction.getSentenceDepTree();
    }

    public Graph getSentenceParseTree(){
        return interaction.getSentenceParseTree();
    }

    public void setSentenceDepTree(Graph tree){
        interaction.setSentenceDepTree(tree);
    }

    public void setSentenceParseTree(Graph tree){
        interaction.setSentenceParseTree(tree);
    }
*/
    public Iterator<String> getNameIterator(){
        return valueMap.keySet().iterator();
    }

    public Object getValue(String key){
    	try{
    		return valueMap.get(key).getFirst();
    	}catch(NullPointerException e){
    		throw new NullPointerException(interaction.getDb_id()+" has a null value in the field: "+key);
    	}
    }

    public String getValueAsString(String key){
    	try{
        	if(key.toLowerCase().contains("tree"))
        		return ((Graph)valueMap.get(key).getFirst()).serialize();
    	}catch(NullPointerException e){
			throw new NullPointerException(interaction.getDb_id()+" has a null value in the field: "+key);
		}
        return valueMap.get(key).getFirst().toString();
    }

    public double getValueAsDouble(String key){
    	try{
    		if(!Ontology.ATTRIBUTE_VALUE_TYPE.isA(getValueType(key), Ontology.NUMERICAL)){
    			LogService.getRoot().log(Level.SEVERE, "Wrong type of InteractionIO attribute "+getValueType(key));
    			return Double.NaN;
    		}
    	}catch(NullPointerException e){
    		throw new NullPointerException(interaction.getDb_id()+" has a null value in the field: "+key);
    	}
        return (Double)valueMap.get(key).getFirst();
    }
    
    public int getValueAsInt(String key){
    	try{
    		if(!Ontology.ATTRIBUTE_VALUE_TYPE.isA(getValueType(key), Ontology.INTEGER)){
    			LogService.getRoot().log(Level.SEVERE, "Wrong type of InteractionIO attribute "+getValueType(key));
    			return Integer.MAX_VALUE;
    		}
    	}catch(NullPointerException e){
    		throw new NullPointerException(interaction.getDb_id()+" has a null value in the field: "+key);
    	}
        return (Integer)valueMap.get(key).getFirst();
    }

    public int getValueType(String key){
        return valueMap.get(key).getSecond();
    }

    public void setValue(String key, Object value, int type){
        valueMap.put(key,new Pair<Object,Integer>(value, type));
    }

    /*public void setKeyType(String key, int role){
        if(role>1){
            LogService.getRoot().log(Level.WARNING, "Unknown role for attribute in interaction object: "+role);
        }else{
            attributeRoles.put(key, ROLES[role]);
        }
    }*/


    public String getExtension() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public String getFileDescription() {
        throw new UnsupportedOperationException("Not supported yet.");
    }



}
