package deeper.operators;

import java.util.Iterator;

import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.ports.InputPort;
import com.rapidminer.operator.ports.OutputPort;

import deeper.entities.Sentence;
import deeper.entities.TextData;
import deeper.entities.rm.io.AbstractIO;

/**
 * Operator that implements filters on text. 
 * Currently only removes empty sentences.
 * @author tfayruzo
 *
 */
public class TextFilterOperator extends Operator{

	private InputPort textInput = getInputPorts().createPort("text", AbstractIO.class);
	private OutputPort textOutput = getOutputPorts().createPort("text");
	
	public TextFilterOperator(OperatorDescription description) {
		super(description);
	}
	
	public void doWork() throws OperatorException{
		AbstractIO abstIO = textInput.getData();
		TextData<Sentence> sents = abstIO.getAbstract().getSentences();
		for(Iterator<Sentence> i = sents.iterator(); i.hasNext(); ){
			Sentence s = i.next();
			if(s.length==0){
				i.remove();
			}
		}
		textOutput.deliver(abstIO);
	}

}
