package deeper.operators;

import com.rapidminer.example.Attribute;
import com.rapidminer.example.Example;
import com.rapidminer.example.ExampleSet;
import com.rapidminer.example.table.NominalMapping;
import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.ports.InputPort;
import com.rapidminer.operator.ports.OutputPort;

import deeper.entities.Abstract;
import deeper.entities.Interaction;
import deeper.entities.Sentence;
import deeper.entities.enums.InteractionLabel;
import deeper.entities.rm.io.TextDataIO;

/**
 * Operator that is supposed to take the output of classifier (ExampleSet with confidence assigned to
 * every row) along with abstracts, that were feed to the classifier through Text2ExampleSetOperator and
 * assign corresponding confidence score to every interaction instance.
 * 
 * 
 */
@Deprecated
public class TextLabellerOperator extends Operator{
	
	InputPort textInput = getInputPorts().createPort("texts", TextDataIO.class);
	InputPort exampleSetInput = getInputPorts().createPort("example set", ExampleSet.class);
	OutputPort textOutput = getOutputPorts().createPort("texts");

	public TextLabellerOperator(OperatorDescription description) {
		super(description);
	}
	
	public void doWork() throws OperatorException{
		TextDataIO<Abstract> abstsIO = textInput.getData();
		ExampleSet exSet = exampleSetInput.getData();
		NominalMapping predMapping = exSet.getAttributes().getPredictedLabel().getMapping();
		for(Abstract abst : abstsIO.getData()){
			for(Sentence s: abst.getSentences()){
				for(Interaction i: s.getInteractions()){
					Example ex = findExample(exSet, i.getExt_id());
					i.confidence = ex.getConfidence(InteractionLabel.POSITIVE.toString());
					if(predMapping.mapIndex((int)ex.getPredictedLabel()).equals(InteractionLabel.NEGATIVE.toString())){
						i.prediction = InteractionLabel.NEGATIVE;
					}else if(predMapping.mapIndex((int)ex.getPredictedLabel()).equals(InteractionLabel.POSITIVE.toString())){
						i.prediction = InteractionLabel.POSITIVE;
					}
					
					//TODO: make the source a parameter
					i.source = "tree SVM";
				}
			}
		}
		textOutput.deliver(abstsIO);
	}
	
	public Example findExample(ExampleSet exSet, String id){
		double idVal = exSet.getAttributes().getId().getMapping().getIndex(id);
		return exSet.getExampleFromId(idVal);
	}

}
