package deeper.operators;

import java.io.IOException;
import java.io.StringReader;

import abner.Scanner;

import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.ports.InputPort;
import com.rapidminer.operator.ports.OutputPort;

import deeper.entities.rm.io.SentenceIO;

/**
 * Simple operator that performs text tokenization. I needed it in order to make protein recognizer 
 * work correctly, as it needs a tokenized input. 
 * @author tfairuzo
 *
 */
public class Tokenizer extends Operator{
	
	private InputPort sentenceInput = getInputPorts().createPort("text", SentenceIO.class);
	private OutputPort sentenceOutput = getOutputPorts().createPort("text");
	
	//TODO: make possible to plug in different tokenizers
	
	public Tokenizer(OperatorDescription description) {
		super(description);
	}
	
	public void doWork() throws OperatorException{
		SentenceIO s = sentenceInput.getData();
		StringBuffer sb = new StringBuffer();
		Scanner scanner = new Scanner(new StringReader(s.getSentence().text));
	    String str;
	    try {
	    	//System.out.println(s.getSentence().getUniqueId()+" "+s.getSentence().text);
			while ((str = scanner.nextToken()) != null) {
				sb.append(str+" ");
			}
		} catch (IOException e) {
			throw new OperatorException("Error tokenizing sentence "+s.getSentence().getExt_id(),e);
		}
		s.getSentence().text = sb.toString();
		sentenceOutput.deliver(s);
	}

}
