/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package deeper.operators.converters;

import java.util.Collection;
import java.util.Set;

import deeper.entities.graph.Edge;
import deeper.entities.graph.Graph;
import deeper.entities.graph.Node;
import edu.umass.cs.mallet.base.types.Instance.Iterator;

/**
 *
 * @author tfairuzo
 */
public class MochittiFormat {

    /**
     * assumes that the input graph is a tree
     * @param tree
     * @return
     */
    public static String convertLex(Graph tree) {
        Node root = tree.getRoot();
    	StringBuffer sb = new StringBuffer("");
        if (root!=null) {
            traverseLex(tree, root, sb);
        }
        return sb.toString();
    }

    private static void traverseLex(Graph g, Node v, StringBuffer sb) {
        sb.append("(" + v.word + " ");
        Collection<Node> children = g.getSuccessors(v);
        if (children.size() > 0) {
            for (Node c: children) {
                traverseLex(g, c, sb);
            }
        } else {
            sb.append("*");
        }
        sb.append(")");
    }

    public static String convertPos(Graph tree) {
    	Node root = tree.getRoot();
    	StringBuffer sb = new StringBuffer("");
        if (root!=null) {
            traversePos(tree, root, sb);
        }
        return sb.toString();
    }

    private static void traversePos(Graph g, Node v, StringBuffer sb) {
    	 sb.append("(" + v.pos + " ");
         Collection<Node> children = g.getSuccessors(v);
         if (children.size() > 0) {
             for (Node c: children) {
                 traverseLex(g, c, sb);
             }
         } else {
             sb.append("*");
         }
         sb.append(")");
    }

    public static String convertSyn(Graph tree) {
    	Node root = tree.getRoot();
    	StringBuffer sb = new StringBuffer("");
        if (root!=null) {
        	sb.append("(*");
            traverseSyn(tree, root, sb);
            sb.append(")");
        }
        return sb.toString();  
    }

    private static void traverseSyn(Graph g, Node v, StringBuffer sb) {
    	Collection<Edge> edges = g.getOutEdges(v);
        if (edges.size() > 0) {
            for (Edge e: edges) {
                sb.append("(" + e.label + " ");
                traverseSyn(g, g.getOpposite(v, e), sb);
            }
        } else {
            sb.append("*");
        }
        sb.append(")");
    }
}
