/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package deeper.operators.converters;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 *
 * @author tfairuzo
 */
public class SVMLight {

    private String train_exec = "c:\\ws\\modelExtension\\libs\\svm\\svm_learn.exe";
    private String test_exec = "c:\\ws\\modelExtension\\libs\\svm\\svm_classify.exe";
    private String model = "c:\\ws\\modelExtension\\libs\\svm\\model.svmlight";
    private double cValue = 1;
    private double LValue = 0.4;
    
    public SVMLight(String train_exec, String test_exec, String model_path, double cValue, double LValue){
    	this.train_exec = train_exec;
    	this.test_exec = test_exec;
    	model = model_path;
    	this.cValue = cValue;
    	this.LValue = LValue;
    }
    
    //constructor for the evaluation nmode
    public SVMLight(String train_exec, String test_exec, String model_path){
    	this.train_exec = train_exec;
    	this.test_exec = test_exec;
    	model = model_path;
    }

    public void train(String trainFile){
        //-L -decay factor in tree computation. default=0.4
        exec(train_exec + " -c " + cValue + " -L " + LValue + " -t 5 -m 200 -a alphas " + trainFile + " " + model);
    }

    public void test(String testFile, String predictions){
        //-L -decay factor in tree computation. default=0.4
        exec(test_exec + " " + testFile + " " + model + " "+predictions);
    }

    public void load(String modelFile){
        model = modelFile;
    }

    private void exec(String command) {
        System.out.println(command);
        try {
            Process p = Runtime.getRuntime().exec(command);
            StreamGobbler errorGobbler = new StreamGobbler(p.getErrorStream(), "SVM ERROR");
            StreamGobbler outputGobbler = new StreamGobbler(p.getInputStream(), "SVM OUTPUT");
            errorGobbler.start();
            outputGobbler.start();
            p.waitFor();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    class StreamGobbler extends Thread {

        InputStream is;
        String type;

        StreamGobbler(InputStream is, String type) {
            this.is = is;
            this.type = type;
        }

        public void run() {
            try {
                InputStreamReader isr = new InputStreamReader(is);
                BufferedReader br = new BufferedReader(isr);
                String line = null;
                while ((line = br.readLine()) != null) {
                    System.out.println(type + ">" + line);
                }
            } catch (IOException ioe) {
                ioe.printStackTrace();
            }
        }
    }

}
