package deeper.operators.converters;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.List;

import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.ports.OutputPort;
import com.rapidminer.parameter.ParameterType;
import com.rapidminer.parameter.ParameterTypeCategory;
import com.rapidminer.parameter.ParameterTypeDouble;
import com.rapidminer.parameter.ParameterTypeFile;

public class TreeSVMModelLoader extends Operator{
	
	public static String PARAMETER_FILE = "file";
	public static String PARAMETER_AB = "file_ab";
	
	OutputPort output = getOutputPorts().createPort("model"); 

	public TreeSVMModelLoader(OperatorDescription description) {
		super(description);
	}
	
	public void doWork() throws OperatorException{
		TreeSVMModel model = new TreeSVMModel();
		if(getParameters().isSet(PARAMETER_AB)){
			try {
				BufferedReader reader = new BufferedReader(new FileReader(getProcess().resolveFileName(getParameterAsString(PARAMETER_AB)).getAbsoluteFile()));
				String s = reader.readLine();
				if(s!=null){
					model.a = Double.parseDouble(reader.readLine());
				}
				s = reader.readLine();
				if(s!=null){
					model.b = Double.parseDouble(reader.readLine());
				}
			} catch (IOException e) {
				throw new OperatorException("Cannot read probability estimator parameters from file");
			}
		}
		model.modelFile = getProcess().resolveFileName(getParameterAsString(PARAMETER_FILE)).getAbsolutePath();
		output.deliver(model);
	}
	

	@Override
	public List<ParameterType> getParameterTypes() {
		List<ParameterType> types = super.getParameterTypes();

		ParameterType type;

		type = new ParameterTypeFile(PARAMETER_FILE, "File with model data","",true);
		types.add(type);
		
		type = new ParameterTypeFile(PARAMETER_AB, "File with parameters for probabilityEstimation", "", false);
		types.add(type);
		
		return types;
	}

}
