/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package deeper.operators.datasets;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.ports.OutputPort;
import com.rapidminer.parameter.ParameterType;
import com.rapidminer.parameter.ParameterTypeDirectory;
import com.rapidminer.parameter.ParameterTypeList;
import com.rapidminer.parameter.ParameterTypeStringCategory;

import deeper.entities.Abstract;
import deeper.entities.TextData;
import deeper.entities.rm.io.AbstractIO;
import deeper.entities.rm.io.InteractionIO;
import deeper.entities.rm.io.TextDataIO;

/**
 * Operator that loads the data from xml files
 * @author tfairuzo
 */
public class LoadInteractionsOperator extends Operator {

    public static final String PARAMETER_XML_SOURCE = "source_directories";
    public static final String PARAMETER_XML_DIR = "directory";

    
    OutputPort textsOutput = getOutputPorts().createPort("texts");
    //OutputPort innerInteractionSource = getSubprocess(0).getInnerSources().createPort("interaction");
    //InputPort innerInteractionSink = getSubprocess(0).getInnerSinks().createPort("interaction");

    public LoadInteractionsOperator(OperatorDescription description) {
        super(description);

        //as far as I understand, we have no input metadata and thus we don't need to modify it,
        //instead just make a stub.

        /*getTransformer().addRule(new GenerateNewMDRule(exampleSetOutput, new ExampleSetMetaData()) {

        @Override
        public MetaData modifyMetaData(MetaData unmodifiedMetaData) {
        // construction of meta data for the Interaction object
        ExampleSetMetaData emd = (ExampleSetMetaData) unmodifiedMetaData;
        emd.addAttribute(new AttributeMetaData("depTree", "tree"));
        emd.addAttribute(new AttributeMetaData("parseTree", "tree"));
        //if subsequent processes require some special data types it is
        //the place to add these types
        return emd;
        }
        });
         */
    }

    @Override
    public void doWork() throws OperatorException {
    	TextData<Abstract> result = new TextData<Abstract>();
        for (String[] pair : getParameterList(PARAMETER_XML_SOURCE)) {
        	File file = getProcess().resolveFileName(pair[1]);
            XMLAbstractIterator abstracts = new XMLAbstractIterator(file);
            while (abstracts.hasNext()) {
            	Abstract inter = abstracts.next();
            	result.add(inter);
            }
        }
        textsOutput.deliver(new TextDataIO<Abstract>(result));
    }

    @Override
    public List<ParameterType> getParameterTypes() {
        List<ParameterType> types = super.getParameterTypes();

        ParameterType type;

        type = new ParameterTypeList(PARAMETER_XML_SOURCE, "In this list arbitrary directories can be specified.",
                new ParameterTypeStringCategory("", "this field is not used", null),
                new ParameterTypeDirectory(PARAMETER_XML_DIR, "Specifies the directory with files.", false));
        type.setExpert(false);
        types.add(type);
        return types;
    }
}
