/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package deeper.operators.treesvm;

import com.rapidminer.example.Attributes;
import com.rapidminer.example.ExampleSet;
import com.rapidminer.operator.Model;
import com.rapidminer.operator.OperatorCapability;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.learner.functions.kernel.JMySVMLearner;
import com.rapidminer.operator.learner.functions.kernel.jmysvm.kernel.Kernel;
import com.rapidminer.parameter.ParameterType;
import com.rapidminer.parameter.ParameterTypeCategory;
import com.rapidminer.parameter.ParameterTypeDouble;
import com.rapidminer.parameter.conditions.EqualTypeCondition;
import java.util.List;
import java.util.ListIterator;

/**
 *
 * @author tfairuzo
 */
@Deprecated
public class TreeSVMLearner extends JMySVMLearner {

    /** The parameter name for &quot;The tree kernel parameter lambda.&quot; */
    public static final String PARAMETER_KERNEL_LAMBDA = "kernel_lambda";
    
    private ExampleSet exSet;
    private double lambda;

    public TreeSVMLearner(OperatorDescription description) {
        super(description);
        //TODO: add precondiotion that checks if the training set contains tree data
        //getInputPorts().getPortByName("training set").addPrecondition(null);
    }

    @Override
    public Model learn(ExampleSet exampleSet) throws OperatorException {
    	lambda = getParameterAsDouble(PARAMETER_KERNEL_LAMBDA);
        exSet = exampleSet;
        return super.learn(exampleSet);
    }

    //only tree kernel is supported
    /*@Override
    public Kernel createKernel(int kernelType) {
    	KernelTree kernel = new KernelTree();
    	kernel.setParameters(lambda, exSet);
    	return kernel;
    }*/
    
    
    
    public boolean supportsCapability(OperatorCapability lc) {
    	if (lc == OperatorCapability.POLYNOMINAL_ATTRIBUTES){
    		return true;
    	}
    	return super.supportsCapability(lc);
    }

    
    
	@Override
    public List<ParameterType> getParameterTypes() {
        List<ParameterType> types = super.getParameterTypes();
        //redefine kernel types parameter to include tree kernels
        ListIterator<ParameterType> i = types.listIterator();
        String[] kernelTypes = new String[KERNEL_TYPES.length+1];
        while(i.hasNext()){
            ParameterType pt = i.next();
            if(pt.getKey().equals(PARAMETER_KERNEL_TYPE)){
                i.remove();
                int ind = 0;
                for(String val : KERNEL_TYPES){
                    kernelTypes[ind++] = val+"(not applicable)";
                }
                kernelTypes[ind] = "tree";
       		ParameterType type = new ParameterTypeCategory(PARAMETER_KERNEL_TYPE, "The SVM kernel type", kernelTypes, 8);
		type.setExpert(false);
                i.add(type);
                break;
            }
        }
        ParameterType type = new ParameterTypeDouble(PARAMETER_KERNEL_LAMBDA, "The tree kernel parameter lambda.", Double.NEGATIVE_INFINITY, Double.POSITIVE_INFINITY, 0.4d);
        type.registerDependencyCondition(new EqualTypeCondition(this, PARAMETER_KERNEL_TYPE, kernelTypes, false, 8));
        type.setExpert(false);
        types.add(type);
        return types;
    }
}