package deeper.parser;

import deeper.entities.graph.Edge;
import deeper.entities.graph.Graph;
import deeper.entities.graph.Node;

/**
 * Local builder isolates JUNG-specific graph building logic 
 * 
 * @author tfayruzo
 *
 */
class DependencyTreeBuilder {

    private Graph depTree;
    private int edgeIndex;

    public void init() {
        depTree = new Graph();
        edgeIndex = 0;
    }


    public void add(Node gov, Node dep, String edgeLabel){
        Edge e = new Edge();
        e.label = edgeLabel;
        e.index = edgeIndex++;
        depTree.addEdge(e,gov,dep);
    }

    public Graph getDepTree() {
        return depTree;
    }
}
