package deeper.parser;

import deeper.entities.graph.Edge;
import deeper.entities.graph.Graph;
import deeper.entities.graph.Node;

/**
 * Local builder isolates JUNG-specific graph building logic
 * 
 * @author tfayruzo
 *
 */
class ParseTreeBuilder {
	private Graph parseTree;
        //enumerates words in the sentence
	private int ind;
        //enumerate vertices that do not represent words
	private int innerInd;
        //enumerates edges
	private int eInd;
        //current node
	private Node parent;
			
	public void init(String label){
		ind = 0;
		innerInd = -1;
		eInd = 0;
		parseTree = new Graph();
                Node v = new Node();
		v.index = innerInd--;
                v.pos = label;
                parseTree.addVertex(v);
		parent = v;
	}
	
	//public void setParent(int index){
	//	parent = parseTree.findVertex(index);
	//	if(parent == null)
	//		(new RuntimeException("Error constructing parse tree")).printStackTrace();
	//}
	
	public Graph getParseTree() {
		return parseTree;
	}
	
	public void addEdge(Node parent, Node child){
            Edge e = new Edge();
            e.index = eInd++;
            parseTree.addEdge(e, parent, child);
	}

        public void moveParent(Node newParent){
            parent = newParent;
        }

        public Node makeLeaf(String word){
            Node n = new Node();
            n.index = ind++;
            n.word = word;
            return n;
        }

        public Node makeInnerNode(String pos){
            Node n = new Node();
            n.index = innerInd--;
            n.pos = pos;
            return n;
        }

        public Node getCurrent(){
            return parent;
        }
	
	/*public int getInternalId(){
		return innerInd;
	}
         */
}
